// event constants

#define eKybd      1         && keyboard event
#define eMenu      2         && menu event
#define eWindow    3         && window selected
#define eClose     5         && close box selected
#define eButton    6         && button selected
#define eScroll    7         && scroll bar selected
#define eMClick   10         && mouse click
#define eWMove    12         && move window
#define eWSize    13         && resize window
#define eDblClick 15         && double click in the client area

#define aClose     1

// color constants

#define cnBlack       0
#define cnBlue        1
#define cnGreen       2
#define cnCyan        3
#define cnRed         4
#define cnMagenta     5
#define cnBrown       6
#define cnLtGray      7
#define cnGray        8
#define cnBtBlue      9
#define cnBtGreen     10
#define cnBtCyan      11
#define cnBtRed       12
#define cnBtMagenta   13
#define cnBtYellow    14
#define cnWhite       15

#define cnBlackOnBlack             0
#define cnBlueOnBlack              1
#define cnGreenOnBlack             2
#define cnCyanOnBlack              3
#define cnRedOnBlack               4
#define cnMagentaOnBlack           5
#define cnBrownOnBlack             6
#define cnWhiteOnBlack             7
#define cnGrayOnBlack              8
#define cnBBlueOnBlack             9
#define cnBGreenOnBlack           10
#define cnBCyanOnBlack            11
#define cnBRedOnBlack             12
#define cnBMagentaOnBlack         13
#define cnBYellowOnBlack          14
#define cnBWhiteOnBlack           15
#define cnBlackOnBlue             16
#define cnBlueOnBlue              17
#define cnGreenOnBlue             18
#define cnCyanOnBlue              19
#define cnRedOnBlue               20
#define cnMagentaOnBlue           21
#define cnBrownOnBlue             22
#define cnWhiteOnBlue             23
#define cnGrayOnBlue              24
#define cnBBlueOnBlue             25
#define cnBGreenOnBlue            26
#define cnBCyanOnBlue             27
#define cnBRedOnBlue              28
#define cnBMagentaOnBlue          29
#define cnBYellowOnBlue           30
#define cnBWhiteOnBlue            31
#define cnBlackOnGreen            32
#define cnBlueOnGreen             33
#define cnGreenOnGreen            34
#define cnCyanOnGreen             35
#define cnRedOnGreen              36
#define cnMagentaOnGreen          37
#define cnBrownOnGreen            38
#define cnWhiteOnGreen            39
#define cnGrayOnGreen             40
#define cnBBlueOnGreen            41
#define cnBGreenOnGreen           42
#define cnBCyanOnGreen            43
#define cnBRedOnGreen             44
#define cnBMagentaOnGreen         45
#define cnBYellowOnGreen          46
#define cnBWhiteOnGreen           47
#define cnBlackOnCyan             48
#define cnBlueOnCyan              49
#define cnGreenOnCyan             50
#define cnCyanOnCyan              51
#define cnRedOnCyan               52
#define cnMagentaOnCyan           53
#define cnBrownOnCyan             54
#define cnWhiteOnCyan             55
#define cnGrayOnCyan              56
#define cnBBlueOnCyan             57
#define cnBGreenOnCyan            58
#define cnBCyanOnCyan             59
#define cnBRedOnCyan              60
#define cnBMagentaOnCyan          61
#define cnBYellowOnCyan           62
#define cnBWhiteOnCyan            63
#define cnBlackOnRed              64
#define cnBlueOnRed               65
#define cnGreenOnRed              66
#define cnCyanOnRed               67
#define cnRedOnRed                68
#define cnMagentaOnRed            69
#define cnBrownOnRed              70
#define cnWhiteOnRed              71
#define cnGrayOnRed               72
#define cnBBlueOnRed              73
#define cnBGreenOnRed             74
#define cnBCyanOnRed              75
#define cnBRedOnRed               76
#define cnBMagentaOnRed           77
#define cnBYellowOnRed            78
#define cnBWhiteOnRed             79
#define cnBlackOnMagenta          80
#define cnBlueOnMagenta           81
#define cnGreenOnMagenta          82
#define cnCyanOnMagenta           83
#define cnRedOnMagenta            84
#define cnMagentaOnMagenta        85
#define cnBrownOnMagenta          86
#define cnWhiteOnMagenta          87
#define cnGrayOnMagenta           88
#define cnBBlueOnMagenta          89
#define cnBGreenOnMagenta         90
#define cnBCyanOnMagenta          91
#define cnBRedOnMagenta           92
#define cnBMagentaOnMagenta       93
#define cnBYellowOnMagenta        94
#define cnBWhiteOnMagenta         95
#define cnBlackOnBrown            96
#define cnBlueOnBrown             97
#define cnGreenOnBrown            98
#define cnCyanOnBrown             99
#define cnRedOnBrown             100
#define cnMagentaOnBrown         101
#define cnBrownOnBrown           102
#define cnWhiteOnBrown           103
#define cnGrayOnBrown            104
#define cnBBlueOnBrown           105
#define cnBGreenOnBrown          106
#define cnBCyanOnBrown           107
#define cnBRedOnBrown            108
#define cnBMagentaOnBrown        109
#define cnBYellowOnBrown         110
#define cnBWhiteOnBrown          111
#define cnBlackOnWhite           112
#define cnBlueOnWhite            113
#define cnGreenOnWhite           114
#define cnCyanOnWhite            115
#define cnRedOnWhite             116
#define cnMagentaOnWhite         117
#define cnBrownOnWhite           118
#define cnWhiteOnWhite           119
#define cnGrayOnWhite            120
#define cnBBlueOnWhite           121
#define cnBGreenOnWhite          122
#define cnBCyanOnWhite           123
#define cnBRedOnWhite            124
#define cnBMagentaOnWhite        125
#define cnBYellowOnWhite         126
#define cnBWhiteOnWhite          127
#define cnBlackOnGray            128
#define cnBlueOnGray             129
#define cnGreenOnGray            130
#define cnCyanOnGray             131
#define cnRedOnGray              132
#define cnMagentaOnGray          133
#define cnBrownOnGray            134
#define cnWhiteOnGray            135
#define cnGrayOnGray             136
#define cnBBlueOnGray            137
#define cnBGreenOnGray           138
#define cnBCyanOnGray            139
#define cnBRedOnGray             140
#define cnBMagentaOnGray         141
#define cnBYellowOnGray          142
#define cnBWhiteOnGray           143
#define cnBlackOnBBlue           144
#define cnBlueOnBBlue            145
#define cnGreenOnBBlue           146
#define cnCyanOnBBlue            147
#define cnRedOnBBlue             148
#define cnMagentaOnBBlue         149
#define cnBrownOnBBlue           150
#define cnWhiteOnBBlue           151
#define cnGrayOnBBlue            152
#define cnBBlueOnBBlue           153
#define cnBGreenOnBBlue          154
#define cnBCyanOnBBlue           155
#define cnBRedOnBBlue            156
#define cnBMagentaOnBBlue        157
#define cnBYellowOnBBlue         158
#define cnBWhiteOnBBlue          159
#define cnBlackOnBGreen          160
#define cnBlueOnBGreen           161
#define cnGreenOnBGreen          162
#define cnCyanOnBGreen           163
#define cnRedOnBGreen            164
#define cnMagentaOnBGreen        165
#define cnBrownOnBGreen          166
#define cnWhiteOnBGreen          167
#define cnGrayOnBGreen           168
#define cnBBlueOnBGreen          169
#define cnBGreenOnBGreen         170
#define cnBCyanOnBGreen          171
#define cnBRedOnBGreen           172
#define cnBMagentaOnBGreen       173
#define cnBYellowOnBGreen        174
#define cnBWhiteOnBGreen         175
#define cnBlackOnBCyan           176
#define cnBlueOnBCyan            177
#define cnGreenOnBCyan           178
#define cnCyanOnBCyan            179
#define cnRedOnBCyan             180
#define cnMagentaOnBCyan         181
#define cnBrownOnBCyan           182
#define cnWhiteOnBCyan           183
#define cnGrayOnBCyan            184
#define cnBBlueOnBCyan           185
#define cnBGreenOnBCyan          186
#define cnBCyanOnBCyan           187
#define cnBRedOnBCyan            188
#define cnBMagentaOnBCyan        189
#define cnBYellowOnBCyan         190
#define cnBWhiteOnBCyan          191
#define cnBlackOnBRed            192
#define cnBlueOnBRed             193
#define cnGreenOnBRed            194
#define cnCyanOnBRed             195
#define cnRedOnBRed              196
#define cnMagentaOnBRed          197
#define cnBrownOnBRed            198
#define cnWhiteOnBRed            199
#define cnGrayOnBRed             200
#define cnBBlueOnBRed            201
#define cnBGreenOnBRed           202
#define cnBCyanOnBRed            203
#define cnBRedOnBRed             204
#define cnBMagentaOnBRed         205
#define cnBYellowOnBRed          206
#define cnBWhiteOnBRed           207
#define cnBlackOnBMagenta        208
#define cnBlueOnBMagenta         209
#define cnGreenOnBMagenta        210
#define cnCyanOnBMagenta         211
#define cnRedOnBMagenta          212
#define cnMagentaOnBMagenta      213
#define cnBrownOnBMagenta        214
#define cnWhiteOnBMagenta        215
#define cnGrayOnBMagenta         216
#define cnBBlueOnBMagenta        217
#define cnBGreenOnBMagenta       218
#define cnBCyanOnBMagenta        219
#define cnBRedOnBMagenta         220
#define cnBMagentaOnBMagenta     221
#define cnBYellowOnBMagenta      222
#define cnBWhiteOnBMagenta       223
#define cnBlackOnBYellow         224
#define cnBlueOnBYellow          225
#define cnGreenOnBYellow         226
#define cnCyanOnBYellow          227
#define cnRedOnBYellow           228
#define cnMagentaOnBYellow       229
#define cnBrownOnBYellow         230
#define cnWhiteOnBYellow         231
#define cnGrayOnBYellow          232
#define cnBBlueOnBYellow         233
#define cnBGreenOnBYellow        234
#define cnBCyanOnBYellow         235
#define cnBRedOnBYellow          236
#define cnBMagentaOnBYellow      237
#define cnBYellowOnBYellow       238
#define cnBWhiteOnBYellow        239
#define cnBlackOnBWhite          240
#define cnBlueOnBWhite           241
#define cnGreenOnBWhite          242
#define cnCyanOnBWhite           243
#define cnRedOnBWhite            244
#define cnMagentaOnBWhite        245
#define cnBrownOnBWhite          246
#define cnWhiteOnBWhite          247
#define cnGrayOnBWhite           248
#define cnBBlueOnBWhite          249
#define cnBGreenOnBWhite         240
#define cnBCyanOnBWhite          251
#define cnBRedOnBWhite           252
#define cnBMagentaOnBWhite       253
#define cnBYellowOnBWhite        254
#define cnBWhiteOnBWhite         255


// keyboard constants

#define kCtrlA               1
#define kCtrlB                                    2
#define kCtrlC               3
#define kCtrlD               4
#define kCtrlE               5
#define kCtrlF               6
#define kCtrlG               7
#define kCtrlH               8
#define kCtrlI               9
#define kCtrlJ               10
#define kCtrlK               11
#define kCtrlL               12
#define kCtrlM               13
#define kCtrlN               14
#define kCtrlO               15
#define kCtrlP               16
#define kCtrlQ               17
#define kCtrlR               18
#define kCtrlS               19
#define kCtrlT               20
#define kCtrlU               21
#define kCtrlV               22
#define kCtrlW               23
#define kCtrlX               24
#define kCtrlY               25
#define kCtrlZ               26

#define kF1                  550
#define kF2                  551
#define kF3                  552
#define kF4                  553
#define kF5                  554
#define kF6                  555
#define kF7                  556
#define kF8                  557
#define kF9                  558
#define kF11                 560
#define kF12                 561

#define kCtrlF1              1550
#define kCtrlF2              1551
#define kCtrlF3              1552
#define kCtrlF4              1553
#define kCtrlF5              1554
#define kCtrlF6              1555
#define kCtrlF7              1556
#define kCtrlF8              1557
#define kCtrlF9              1558
#define kCtrlF11             1560
#define kCtrlF12             1561

#define kShiftF1             1650
#define kShiftF2             1651
#define kShiftF3             1652
#define kShiftF4             1653
#define kShiftF5             1654
#define kShiftF6             1655
#define kShiftF7             1656
#define kShiftF8             1657
#define kShiftF9             1658
#define kShiftF11            1660
#define kShiftF12            1661

#define kEnter               13
#define kCtrlEnter           513

#define kEsc                 27
#define kDel                 484

#define kUp                  529
#define kPgUp                530
#define kDown                535
#define kPgDn                536

#define kCtrlHome            539
#define kCtrlUp              540
#define kCtrlEnd             545
#define kCtrlDn              546

#define csNoDataFile                      'No Data File'
#define csCARETRunErr             'CA-RET Run Error'
#define csCARETErr                        'CA-RET Error'        
#define csCARETNotRun             'CA-RET Runtime not running'
#define csCARETNoStatInfo         'Cannot get status information from CA-RET'
