SET PROCEDURE TO LIBAUTO

// Funciones para el control de Archivos y Registros
// NET_USE  //  FIL_LOCK  //  REC_LOCK  //   ADD_REC
// 15/6/1992 - 12/9/1994 - 1/3/95 -( 27/11/97 modificado para Windows DBFAST) 
/////////////////////////////////////////////////////////////////////////////
// FUNCION net_use()
// Intenta obrir un fitxer en modo EXCLUSIVO o COMPARTIDO
// IF net_use("&ano\provedor", .f., 0)
//  OpenIndex("&ano\provedor")
//  IF rec_lock(0)
//   REPLACE MARCAR WITH ""
//  ENDIF
// ENDIF

FUNCTION net_use
PARAMETERS file, ex_use, wait
PRIVATE forever
forever = (wait = 0)
DO WHILE (forever .OR. wait > 0)
 IF ex_use
  SET EXCLUSIVE ON               // Archivo Exclusivo
 ELSE
  SET EXCLUSIVE OFF														// Archivo Compartido
	ENDIF
 IF .NOT. NETERR() 
  RETURN (.T.)
 ENDIF
	MESSAGE("Control de Archivos", "El Archivo actual esta ocupado por otro Usuario.") 
 wait = wait -1
 IF LASTKEY()=27
  EXIT
 ENDIF
ENDDO
RETURN(.F.) 

// FUNCION fil_lock()
// Intenta bloquear el fitxer compartit vigent.
// IF net_use("&ano\provedor", .t., 0)
//  If fil_lock(0)
//   IF rec_lock(0)
//    delete for marcar = ""
//    pack
//   Endif
//  ENDIF
// ENDIF


FUNCTION fil_lock
PARAMETERS wai
PRIVATE forever
*/
IF FLOCK()
 RETURN (.T.)      
ENDIF
forever = (wai = 0)
DO WHILE (forever .OR. wai > 0)
	MESSAGE("Control de Archivos", "El archivo actual esta ocupado por otro Usuario.") 
 wai = wai - .5
 IF LASTKEY()=27
  EXIT
 ENDIF
 IF FLOCK()
  RETURN (.T.)
 ENDIF
ENDDO
RETURN (.F.)   

// FUNCION rec_lock()
// IF net_use("&ano\provedor", .f., 0)
//  OpenIndex("&ano\provedor")
//  IF rec_lock(0)
//   REPLACE MARCAR WITH ""
//  ENDIF
// ENDIF
// Intenta bloquear el registro vigente.

FUNCTION rec_lock
PARAMETERS wait
PRIVATE forever
*/
IF RLOCK()
 RETURN (.T.)            
ENDIF
forever = (wait = 0)
DO WHILE (forever .OR. wait > 0)
	MESSAGE("Control de Archivos", "El Registro actual esta ocupado por otro Usuario.") 
 wait = wait - .5
 IF LASTKEY()=27
  EXIT
 ENDIF
 IF RLOCK()
  RETURN (.T.)         
 ENDIF
ENDDO
RETURN (.F.)                  

// FUNCION add_rec()
// Devuelve .T. si el registro se aadio correctamente. El nuevo
// registro queda bloqueado y pasa a ser el vigente.
//  IF net_use("&ano\provedor", .f., 0)
//   OpenIndex("&ano\provedor")
//   IF add_rec(0)
//    REPLACE PROVEIDOR WITH p_prove
//			ENDIF
//  ENDIF

FUNCTION add_rec
PARAMETERS wait
PRIVATE forever
*/
*APPEND BLANK
*IF .NOT. NETERR()
* RETURN (.T.)
*ENDIF
forever = (wait = 0)
DO WHILE (forever .OR. wait > 0)
 APPEND BLANK
 IF .NOT. NETERR()
  RETURN .T.
 ENDIF
	MESSAGE("Control de Archivos", "No a sido posible aadir un registro a la Base de Datos Actual.") 
 wait = wait - .5
 IF LASTKEY()=27
  EXIT
 ENDIF
ENDDO
RETURN (.F.)

///////////////////////////////////////////////////////////////////
// Funcin para desbloquear Registro o Archivos
// R = Desbloquea registros A = Desbloquea Archivos

Function Desbloq
Parameters Xd

IF Xd = "R"
	UNLOCK
ELSE
	UNLOCK ALL
ENDIF

Return .t.

************************************************
// Funcun para localizar palabras directamente
FUNCTION FindText()
************************************************
Target = RECNO()

SET SOFTSEEK ON
SEEK TRIM(UPPER(LookUp))

IF .NOT.EOF().AND.Target<>RECNO()
	nLin=RECNO()
	UPDATE CONTROL 'Br'
ELSE
	GOTO Target
ENDIF
RETURN(.T.)

************************************************
// Funcin para localizar nmeros directamente
FUNCTION FindNum()
************************************************
Target = RECNO()

SET SOFTSEEK ON
BuscarLookUpNum = VAL(LookUp)
SEEK BuscarLookUpNum

IF .NOT. EOF() .AND. Target <> RECNO()
	nLin=RECNO()
	UPDATE CONTROL 'Br'
ELSE
	GOTO Target
ENDIF
RETURN(.T.)

**********************************************************
Function Ventana
parameter sTitulo, subTitulo, nAlto, nAncho, nVentana

nResolucion = HARDWARE(2)             // Resolucion de la pantalla

  nReturn = .t.
		IF nResolucion = 640
	  IF nAncho > 79 .or. nAncho < 20 .or. nAlto > 26 .or. nAlto < 4
				nAncho = 79
				nAlto = 26
				nSupFila = int((26 - (nAlto + 1)) / 2)
				IF nSupFila > 7
			  nSupFila = int((16 - (nAlto + 1)) / 2)
				ENDIF
				nSupCol = int((79 - nAncho) / 2)
				nBotFila = nSupFila + (nAlto + 1)
				nBotCol = nSupCol + nAncho
	  ELSE
				nSupFila = int((26 - (nAlto + 1)) / 2)
				IF nSupFila > 7
			  nSupFila = int((16 - (nAlto + 1)) / 2)
				ENDIF
				nSupCol = int((79 - nAncho) / 2)
				nBotFila = nSupFila + (nAlto + 1)
				nBotCol = nSupCol + nAncho
			ENDIF
		ELSE
	  IF nAncho > 100 .or. nAncho < 20 .or. nAlto > 30 .or. nAlto < 2
				nAncho = 99
				nAlto = 30
				nSupFila = int((30 - (nAlto + 1)) / 2)
				IF nSupFila > 7
			  nSupFila = int((16 - (nAlto + 1)) / 2)
				ENDIF
				nSupCol = int((100 - nAncho) / 2)
				nBotFila = nSupFila + (nAlto + 1)
				nBotCol = nSupCol + nAncho
	  ELSE
				nSupFila = int((30 - (nAlto + 1)) / 2)
*				IF nSupFila > 7
*			  nSupFila = int((16 - (nAlto + 1)) / 2)
*				ENDIF
				nSupCol = int((100 - nAncho) / 2)
				nBotFila = nSupFila + (nAlto + 1)
				nBotCol = nSupCol + nAncho
			ENDIF
		ENDIF

			// Crea la ventana
			SET WINDOW TYPE TO nVentana
			CREATE WINDOW sTitulo FROM nSupFila,nSupCol TO nBotFila,nBotCol STYLE RAISED
			SELECT WINDOW sTitulo VIEW
			IF .NOT. EMPTY(subTitulo)
		  SET WINDOW TITLE TO subTitulo
			ENDIF
			SET ERASE VIDEO TO 116
			ERASE

Return .t.
***************************
Function CtrlIniMem()
***************************
IF FILE("salida.mem")
	restore from salida.mem additive
ELSE
 mSalida = .T.
 save all like mSalida to salida.mem
ENDIF

IF mSalida = .T.
	mSalida = .T.
ELSE
 mSalida = .F.
	BEEP
	WARNING("Error","Se ha detectado que la ltima vez se sali incorrectamente del programa."+chr(13)+"A continuacin se optimarn todas las Bases de Datos del programa.",1+384)
ENDIF
Return(mSalida)

***************************
Function CtrlFinMem()
***************************
mSalida = .T.
save all like mSalida to salida.mem
Return(mSalida)

Function CopyMonth()
// Aviso de Copia
// Realiza una copia de todos los archivos en el directrio COPIA
IF FILE("AVISO.MEM")
	RESTORE FROM AVISO.MEM ADDITIVE	
	IF MONTH(DATE()) <> UltimoMes
		BEEP
		WARNING("Copia de Seguridad","Le recuerdo que tiene que realizar Copias de Seguridad de los datos del programa."+chr(13)+"El programa har una copia de todos los datos en un directorio auxiliar [COPIA] una vez al mes.",1+384)
		UltimoMes = MONTH(DATE())
		SAVE ALL LIKE UltimoMes TO AVISO.MEM
		IF FILE("VEHICLES.NDX")
			// ARCHIVOS DBF
			STORE ADIR("*.DBF") TO var1
			DECLARE nomarchivo[var1]
			ADIR("*.DBF",@nomarchivo)
			GAUGE('Copia de Seguridad *.DBF', 0, var1)
			FOR NdxPrimero = 1 TO Var1
				GAUGE('', NdxPrimero, 0)
				ArchivoBorrar = nomarchivo[NdxPrimero]
				SET MESSAGE TO "Copiando ... &DirActual.&ArchivoBorrar. A &DirActual.COPIA\&ArchivoBorrar."
				COPY FILE &DirActual.&ArchivoBorrar. TO &DirActual.COPIA\&ArchivoBorrar.
			NEXT
			GAUGE('', 0, 0)
			// ARCHIVOS DBT
			STORE ADIR("*.DBT") TO var1
			DECLARE Xomarchivo[var1]
			ADIR("*.DBT",@Xomarchivo)
			GAUGE('Copia de Seguridad *.DBT', 0, var1)
			FOR NdxPrimero = 1 TO Var1
				GAUGE('', NdxPrimero, 0)
				ArchivoBorrar = Xomarchivo[NdxPrimero]
				SET MESSAGE TO "Copiando ... &DirActual.&ArchivoBorrar. A &DirActual.COPIA\&ArchivoBorrar."
				COPY FILE &DirActual.&ArchivoBorrar. TO &DirActual.COPIA\&ArchivoBorrar.
			NEXT
			GAUGE('', 0, 0)
			// ARCHIVOS MEM
			STORE ADIR("*.MEM") TO var1
			DECLARE Fomarchivo[var1]
			ADIR("*.MEM",@Fomarchivo)
			GAUGE('Copia de Seguridad *.MEM', 0, var1)
			FOR NdxPrimero = 1 TO Var1
				GAUGE('', NdxPrimero, 0)
				ArchivoBorrar = Fomarchivo[NdxPrimero]
				SET MESSAGE TO "Copiando ... &DirActual.&ArchivoBorrar. A &DirActual.COPIA\&ArchivoBorrar."
				COPY FILE &DirActual.&ArchivoBorrar. TO &DirActual.COPIA\&ArchivoBorrar.
			NEXT
			GAUGE('', 0, 0)
		ENDIF
		SET MESSAGE TO ""
	ENDIF
ELSE
	UltimoMes = MONTH(DATE())
	SAVE ALL LIKE UltimoMes TO AVISO.MEM
ENDIF
Return .t.